/*
 =================================================================================================
 // Game structurs and defines
 // Created by faceH0r 12.08.2005
 =================================================================================================
*/

#ifndef _REDGUTS_H
#define _REDGUTS_H

// ===============================================================================================

	#define RGS_COUNT_WEAPONS		4

	#define RGS_COUNT_BUL_SHOTGUN	8

	#define RGS_IDENT_PISTOL		100
	#define RGS_IDENT_AK			101
	#define RGS_IDENT_SHOTGUN		102
	#define RGS_IDENT_GRENADE		103

	#define RGS_BONUS_FAST_SPEED	200
	#define RGS_BONUS_FAST_SHOT		201
	#define RGS_BONUS_AK			202
	#define RGS_BONUS_SHOTGUN		203
	#define RGS_BONUS_GRENADEGUN	204
	#define RGS_BONUS_HEALTH		205
	#define RGS_BONUS_2XSPECIAL		206
	#define RGS_BONUS_100SCORE		207
	#define	RGS_BONUS_2XALL			208

	#define RGS_MAX_FAST_SPEED_TIME	10000
	#define RGS_MAX_FAST_SHOT_TIME	15000

	#define RGS_PI					3.1415926535

// ===============================================================================================

	typedef struct _s_main{
		WNDCLASSEX m_Wc;

		HWND hWnd;
		HDC hDc;
		HGLRC hRc;

		MSG uMsg;

		POINT m_Pos;
		POINT m_PosPause;

		c_vec_2d fm_Pos;

		float time_Current;
		float time_Delta;
		float time_Old;

		float speed_Game;

		float f_SoundDamage;
		float f_SoundPlayerDamage;
		float f_SpeedRespawn;
		float f_StartSpeedRespawn;

		float f_PressAnyKey;

		unsigned int text_Base[2];
		unsigned int player_Score;

		int select_nmb;
		int i_ShowFPS;

		bool lbtn;
		bool rbtn;
		bool b_score;

		bool game_Pause;
		bool game_Menu;
		bool game_BuyMenu;

		bool keys[256];

		DEVMODE dm;

		int sc_Width;
		int sc_Height;

		ALCdevice *pDevice;
		ALCcontext *pContext;
	}s_main;

// ===============================================================================================

	typedef struct _s_rgb{
		float r;
		float g;
		float b;
	}s_rgb;

// ===============================================================================================

	typedef struct _s_line{
		c_vec_2d v_Start;
		c_vec_2d v_End;
	}s_line;

// ===============================================================================================

	typedef struct _s_animation_sprite{
		float f_Blend;
		float f_Size;
		float f_SpeedDestroy;

		float f_SpeedAnimation;
		float f_CurrentTime;

		int i_CurrentFrame;
		int i_CountFrames;

		bool b_Play;

		unsigned int ui_TextureNumber;

		c_vec_2d v_Pos;
		c_vec_2d v_Dir;
		c_vec_2d v_Point[4];
	}s_animation_sprite;

// ===============================================================================================

	typedef struct _s_static_sprite{
		float f_Blend;
		float f_Size;
		float f_SpeedDestroy;

		unsigned int ui_TextureNumber;

		c_vec_2d v_Pos;
		c_vec_2d v_Dir;
		c_vec_2d v_Point[4];
	}s_static_sprite;

// ===============================================================================================

	typedef struct _s_particle{
		float f_Blend;
		float f_SpeedDestroy;
		float f_SpeedMove;
		float f_Resistance;

		int i_AngleScatter;

		s_rgb p_color;

		c_vec_2d v_Pos;
		c_vec_2d v_Dir;
	}s_particle;

// ===============================================================================================

	typedef struct _s_bonus{
		int i_BonusType;

		float f_CurrentTimeLive;
		float f_AllTimeLive;
		float f_Size;

		c_vec_2d v_Pos;
		c_vec_2d v_OldPos;

		s_line ln[4];
	}s_bonus;

// ===============================================================================================

	typedef struct _s_weapon{
		float time_BetweenShot;
		float time_Reload;
		
		int count_Patrons;
		int count_InLoad;

		char name[256];
	}s_weapon;

// ===============================================================================================

	typedef struct _s_player{
		float f_TimeBetweenTrace;
		float f_CurrentTraceTime;
		float f_SpeedDestroyTrace;

		float f_RecoverPowerRunSpeed;

		float f_CurrentShotTime;
		float f_CurrentReloadWeaponTime;
		float f_CurrentSpecialTime;

		float f_CurrentFastSpeedTime;
		float f_CurrentFastShotTime;

		int i_CountSpecial;
		int i_NumberAnimation;

		float p_Health;

		float p_RunPower;

		s_weapon Weapon[RGS_COUNT_WEAPONS];

		int count_Weapons;
		int w_Id[RGS_COUNT_WEAPONS];

		int current_Weapon;

		int count_Bonuses;

		bool b_FirstBlood;
		bool b_Dead;

		bool bonus_FastSpeed;
		bool bonus_FastShot;

		c_vec_2d v_Dir;
		c_vec_2d v_Pos;
		c_vec_2d v_Vel;
		c_vec_2d v_DirMove;
	}s_player;

// ===============================================================================================

	typedef struct _s_monster{
		c_vec_2d m_Pos;
		c_vec_2d m_Vel;
		c_vec_2d m_Dir;

		s_line ln[4];

		float m_Speed;
		float m_Damage;
		float m_Health;
		float m_Size;

		float time_CurrentReload;
		float time_Reload;

		int nmb_Anim;
		int get_Score;
		int i_Texture;
	}s_monster;

// ===============================================================================================

	typedef struct _s_bullet{
		c_vec_2d b_Pos;
		c_vec_2d b_Vel;

		float b_Speed;

		float f_Damage;

		bool b_Explosion;
		bool b_Score;
	}s_bullet;

// ===============================================================================================

	typedef struct _s_monster_setting{
		float f_Damage;
		float f_Health;
		float f_Size;
		float f_Speed;
		float f_ReloadTime;

		int i_Score;
		int i_Texture;

		char name[256];
		char namet[256];
	}s_monster_setting;

// ===============================================================================================

	typedef struct _s_bullet_setting{
		float f_Damage;
		float f_Speed;

		int i_Random;
		
		bool b_Score;
		bool b_Explosion;

		char name[256];
	}s_bullet_setting;

// ===============================================================================================

	typedef struct _s_texture_setting{
		int i_Number;

		char name[256];
	}s_texture_setting;

// ===============================================================================================

	typedef struct _s_particle_setting{
		int i_Scatter;

		float f_Blend;
		float f_SpeedDestroy;
		float f_SpeedMove;
		float f_Resistance;
		float f_R;
		float f_G;
		float f_B;

		char name[256];
	}s_particle_setting;

// ===============================================================================================

	typedef struct _s_explosion{
		float f_Size;
		float f_Blend;

		int i_NumberAnimation;

		c_vec_2d v_Pos;
		c_vec_2d v_Dir;
	}s_explosion;

// ===============================================================================================

	typedef struct _s_renderbonus{
		float f_Blend;

		char name[256];
	}s_renderbonus;

// ===============================================================================================

#endif _REDGUTS_H