/*
	==============================================================================================
	// RedGutS
	// Created by faceH0r 12.08.2005
	==============================================================================================
*/
	#pragma comment(lib,"opengl32.lib")
	#pragma comment(lib,"glu32.lib")
	#pragma comment(lib,"glaux.lib")
	
	#pragma comment(lib,"openal32.lib")
	#pragma comment(lib,"alut.lib")

	#include <windows.h>

	#include <gl/gl.h>
	#include <gl/glu.h>
	#include <gl/glaux.h>

	#include <al/al.h>
	#include <al/alu.h>
	#include <al/alc.h>
	#include <alut/alut.h>

	#include <stdio.h>

	#include <math.h>

	#include "Vector2D.h"

	#include "RedGutS.h"

// ===============================================================================================
//  Globals variables
// ===============================================================================================

	s_main mm;
	s_player plr;

	s_bullet blt[1024];
	int c_Bullets=0;

	s_monster mst[1024];
	float current_Time=0.0f;
	int c_Monsters=0;

	s_bonus bns[1024];
	int c_Bonus=0;

	s_particle par[1024];
	int c_Particles=0;

	s_animation_sprite ani[4096];
	int c_Animation=0;

	s_static_sprite spr[2096];
	int c_Sprites=0;

	unsigned int tex[64];
	int c_Textures=0;

	s_monster_setting m_FF[32];
	int c_monster_settings=0;

	s_bullet_setting b_FF[32];
	int c_bullet_settings=0;

	s_texture_setting t_FF[32];
	int c_texture_settings=0;

	s_particle_setting FF_par[32];
	int c_particle_settings=0;

	ALuint snd[64];
	ALuint sndb[64];
	int c_SoundBuffers=0;

	s_renderbonus rbonus;

	float		fTimer = 0.0f;

// ===============================================================================================
//  Heads functions forward
// ===============================================================================================

	void Animation_Add(const s_animation_sprite &ani_sprite);
	void Animation_Del(const int &number);
	void Animation_PointsCalculate(const int &number,const s_animation_sprite &ani_sprite);
	void Animation_Update();
	void Animation_Render();

	void Sprite_Add(const s_static_sprite &sprite);
	void Sprite_Del(const int &number);
	void Sprite_Update();
	void Sprite_Render();

	void Particle_Add(const s_particle &particle);
	void Particle_Del(const int &number);
	void Particle_Update();
	void Particle_Render();

	void Bonus_Add(const s_bonus &bonus);
	void Bonus_Del(const int &number);
	void Bonus_TestPlayer(const int &number);
	void Bonus_CalculateBoudingLines(const int &number);
	void Bonus_Update();
	void Bonus_Render();

	void Monster_Add(const s_monster &monster);
	void Monster_Update();
	void Monster_Render();
	void Monster_Del(const int &number);

	void Standart_BloodSprite(const c_vec_2d &pos);
	void Standart_ExplosionSpotSprite(const c_vec_2d &pos);
	void Standart_ToothDeadSprite(const s_monster &monster);

	void Monster_Respawn(const char *name,const c_vec_2d &pos);
	void Monster_Load(const char *name);

	void Text_BuildFont(const char *name,const int &width,const int &height,const int number);
	void Text_Printf(const int number,const float &x,const float &y,const char *text,...);

	void Setting_Weapon(const int &id,const char *name,const int &c_Patrons,const float &t_Bt,const float &t_R);

	void RedGutS_ProcessKeys();
	void RedGutS_Init();
	void RedGutS_Render();
	void RedGutS_Exit();
	void RedGutS_LoadSettings(const char *name);

	void Player_AddWeapon(const int &id);
	void Player_Render();

	void Bullet_Add(const s_bullet &blt);
	void Bullet_Del(int nmb);
	void Bullet_Test();
	void Bullet_Update();
	void Bullet_Render();

	void Texture_Call(int nmb);
	void Texture_GenerateGrass(const char *name);
	void Texture_Load(const char *fname);
	void Texture_CallByName(const char *name);

	void Shot_Test();

	int GetMonsterByName(const char *name);
	int GetTextureByName(const char *name);
	int GetBulletByName(const char *name);
	int GetParticleByName(const char *name);

	bool Test_CrossLines(s_line ln1,s_line ln2);

	void SetDCPixelFormat(HDC hDc);

	void OAL_Play(int number);

	void New_Game();

	LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam);
	WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd);

// ===============================================================================================
//  Static sprite no animation
// ===============================================================================================

void Sprite_Add(const s_static_sprite &sprite){
	spr[c_Sprites]=sprite;

	//////////////////////////////////////////////////////////////////////////////////////////////
	// Calculate 4 points for sprites ussualy direct
	//////////////////////////////////////////////////////////////////////////////////////////////
	// It is algorithm : 
	// point.x=pos.x+(dir.x+dir.normal.x)*size;
	// maybe + & -
	//////////////////////////////////////////////////////////////////////////////////////////////

	spr[c_Sprites].v_Point[0].x=spr[c_Sprites].v_Pos.x+
		(spr[c_Sprites].v_Dir.x+spr[c_Sprites].v_Dir.vecNormal().x)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[0].y=spr[c_Sprites].v_Pos.y+
		(spr[c_Sprites].v_Dir.y+spr[c_Sprites].v_Dir.vecNormal().y)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[1].x=spr[c_Sprites].v_Pos.x+
		(spr[c_Sprites].v_Dir.x-spr[c_Sprites].v_Dir.vecNormal().x)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[1].y=spr[c_Sprites].v_Pos.y+
		(spr[c_Sprites].v_Dir.y-spr[c_Sprites].v_Dir.vecNormal().y)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[2].x=spr[c_Sprites].v_Pos.x-
		(spr[c_Sprites].v_Dir.x+spr[c_Sprites].v_Dir.vecNormal().x)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[2].y=spr[c_Sprites].v_Pos.y-
		(spr[c_Sprites].v_Dir.y+spr[c_Sprites].v_Dir.vecNormal().y)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[3].x=spr[c_Sprites].v_Pos.x-
		(spr[c_Sprites].v_Dir.x-spr[c_Sprites].v_Dir.vecNormal().x)*spr[c_Sprites].f_Size;
	spr[c_Sprites].v_Point[3].y=spr[c_Sprites].v_Pos.y-
		(spr[c_Sprites].v_Dir.y-spr[c_Sprites].v_Dir.vecNormal().y)*spr[c_Sprites].f_Size;

	// Increase count sprites
	c_Sprites++;
}

// ===============================================================================================

void Sprite_Del(const int &number){
	for(int i=number;i<c_Sprites;i++)
		spr[i]=spr[i+1];

	c_Sprites--;
}

// ===============================================================================================

void Sprite_Update(){
	for(int i=0;i<c_Sprites;i++){
		spr[i].f_Blend-=spr[i].f_SpeedDestroy*mm.time_Delta;

		if(spr[i].f_Blend<=0.0f)
			Sprite_Del(i);
	}
}

// ===============================================================================================

void Sprite_Render(){
	int i;

	Sprite_Update();

	glEnable(GL_TEXTURE_2D);

	for(i=0;i<c_Sprites;i++){
		Texture_Call(spr[i].ui_TextureNumber);

		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,spr[i].f_Blend);

			glTexCoord2d(0.0f,0.0f);
			glVertex2f(spr[i].v_Point[0].x,spr[i].v_Point[0].y);
			glTexCoord2d(0.0f,1.0f);
			glVertex2f(spr[i].v_Point[1].x,spr[i].v_Point[1].y);
			glTexCoord2d(1.0f,1.0f);
			glVertex2f(spr[i].v_Point[2].x,spr[i].v_Point[2].y);
			glTexCoord2d(1.0f,0.0f);
			glVertex2f(spr[i].v_Point[3].x,spr[i].v_Point[3].y);
		glEnd();
	}

	glDisable(GL_TEXTURE_2D);
}

// ===============================================================================================
//  Sprite & animation
// ===============================================================================================

void Animation_PointsCalculate(const int &number,const s_animation_sprite &ani_sprite){
	s_animation_sprite s=ani_sprite;

	ani[number].v_Point[0].x=s.v_Pos.x+(s.v_Dir.x+s.v_Dir.vecNormal().x)*s.f_Size;
	ani[number].v_Point[0].y=s.v_Pos.y+(s.v_Dir.y+s.v_Dir.vecNormal().y)*s.f_Size;
	ani[number].v_Point[1].x=s.v_Pos.x+(s.v_Dir.x-s.v_Dir.vecNormal().x)*s.f_Size;
	ani[number].v_Point[1].y=s.v_Pos.y+(s.v_Dir.y-s.v_Dir.vecNormal().y)*s.f_Size;
	ani[number].v_Point[2].x=s.v_Pos.x-(s.v_Dir.x+s.v_Dir.vecNormal().x)*s.f_Size;
	ani[number].v_Point[2].y=s.v_Pos.y-(s.v_Dir.y+s.v_Dir.vecNormal().y)*s.f_Size;
	ani[number].v_Point[3].x=s.v_Pos.x-(s.v_Dir.x-s.v_Dir.vecNormal().x)*s.f_Size;
	ani[number].v_Point[3].y=s.v_Pos.y-(s.v_Dir.y-s.v_Dir.vecNormal().y)*s.f_Size;
}

// ===============================================================================================

void Animation_Add(const s_animation_sprite &ani_sprite){
	ani[c_Animation]=ani_sprite;

	Animation_PointsCalculate(c_Animation,ani_sprite);

	c_Animation++;
}

// ===============================================================================================

void Animation_Del(const int &number){
	for(int i=number;i<c_Animation;i++)
		ani[i]=ani[i+1];

	c_Animation--;
}

// ===============================================================================================

void Animation_Update(){
	for(int i=0;i<c_Animation;i++){
		if(ani[i].b_Play){
			ani[i].f_CurrentTime+=ani[i].f_SpeedAnimation*mm.time_Delta;

			if(ani[i].f_CurrentTime>=1000){
				ani[i].f_CurrentTime=0.0f;
				ani[i].i_CurrentFrame++;

				if(ani[i].i_CurrentFrame>ani[i].i_CountFrames-1)
					ani[i].i_CurrentFrame=0;
			}

			if(ani[i].f_SpeedDestroy!=0.0f)
				ani[i].f_Blend-=ani[i].f_SpeedDestroy*mm.time_Delta;

			if(ani[i].f_Blend<=0.0f){
				for(int j=0;j<c_Monsters;j++)
					if(mst[j].nmb_Anim>=i)
						mst[j].nmb_Anim--;

				Animation_Del(i);
			}
		}
	}
}

// ===============================================================================================

void Animation_Render(){
	Animation_Update();

	glEnable(GL_TEXTURE_2D);

	for(int i=0;i<c_Animation;i++){
		Texture_Call(ani[i].ui_TextureNumber);

		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,ani[i].f_Blend);

			glTexCoord2f(ani[i].i_CurrentFrame*1.0f/ani[i].i_CountFrames,0.0f);
			glVertex2f(ani[i].v_Point[0].x,ani[i].v_Point[0].y);
			glTexCoord2f(ani[i].i_CurrentFrame*1.0f/ani[i].i_CountFrames,1.0f);
			glVertex2f(ani[i].v_Point[1].x,ani[i].v_Point[1].y);
			glTexCoord2f(1.0f/ani[i].i_CountFrames+ani[i].i_CurrentFrame*1.0f/ani[i].i_CountFrames,1.0f);
			glVertex2f(ani[i].v_Point[2].x,ani[i].v_Point[2].y);
			glTexCoord2f(1.0f/ani[i].i_CountFrames+ani[i].i_CurrentFrame*1.0f/ani[i].i_CountFrames,0.0f);
			glVertex2f(ani[i].v_Point[3].x,ani[i].v_Point[3].y);
		glEnd();
	}

	glDisable(GL_TEXTURE_2D);
}

// ===============================================================================================
//  Particle
// ===============================================================================================

void Particle_Add(const s_particle &particle){
	par[c_Particles]=particle;

	par[c_Particles].v_Dir.vecRotate((rand()%par[c_Particles].i_AngleScatter-
		                            par[c_Particles].i_AngleScatter/2)/180.0f*RGS_PI);

	c_Particles++;
}

// ===============================================================================================

void Particle_Del(const int &number){
	for(int i=number;i<c_Particles;i++)
		par[i]=par[i+1];

	c_Particles--;
}

// ===============================================================================================

void Particle_Update(){
	for(int i=0;i<c_Particles;i++){
		par[i].f_Blend-=par[i].f_SpeedDestroy*mm.time_Delta;

		if(par[i].f_Blend<=0.0f)
			Particle_Del(i);

		par[i].f_SpeedMove/=par[i].f_Resistance;

		par[i].v_Pos+=par[i].v_Dir*par[i].f_SpeedMove*mm.time_Delta;
	}
}

// ===============================================================================================

void Particle_Render(){
	Particle_Update();

	glEnable(GL_POINT_SMOOTH);

	glPointSize(3.0f);

	glBegin(GL_POINTS);
		for(int i=0;i<c_Particles;i++){
			glColor4f(par[i].p_color.r,par[i].p_color.g,par[i].p_color.b,par[i].f_Blend);

			glVertex2f(par[i].v_Pos.x,par[i].v_Pos.y);
		}
	glEnd();

	glDisable(GL_POINT_SMOOTH);
}

// ===============================================================================================
//  Bonus
// ===============================================================================================

void Bonus_Add(const s_bonus &bonus){
	bns[c_Bonus]=bonus;

	c_Bonus++;
}

// ===============================================================================================

void Bonus_Del(const int &number){
	for(int i=number;i<c_Bonus;i++)
		bns[i]=bns[i+1];
	
	c_Bonus--;
}

// ===============================================================================================

void Bonus_CalculateBoudingLines(const int &number){
	bns[number].ln[0].v_Start.x=bns[number].v_Pos.x-bns[number].f_Size*1.5f;
	bns[number].ln[0].v_Start.y=bns[number].v_Pos.y-bns[number].f_Size*1.5f;
	bns[number].ln[0].v_End.x=bns[number].v_Pos.x-bns[number].f_Size*1.5f;
	bns[number].ln[0].v_End.y=bns[number].v_Pos.y+bns[number].f_Size*1.5f;

	bns[number].ln[1].v_Start.x=bns[number].v_Pos.x-bns[number].f_Size*1.5f;
	bns[number].ln[1].v_Start.y=bns[number].v_Pos.y+bns[number].f_Size*1.5f;
	bns[number].ln[1].v_End.x=bns[number].v_Pos.x+bns[number].f_Size*1.5f;
	bns[number].ln[1].v_End.y=bns[number].v_Pos.y+bns[number].f_Size*1.5f;

	bns[number].ln[2].v_Start.x=bns[number].v_Pos.x+bns[number].f_Size*1.5f;
	bns[number].ln[2].v_Start.y=bns[number].v_Pos.y+bns[number].f_Size*1.5f;
	bns[number].ln[2].v_End.x=bns[number].v_Pos.x+bns[number].f_Size*1.5f;
	bns[number].ln[2].v_End.y=bns[number].v_Pos.y-bns[number].f_Size*1.5f;

	bns[number].ln[3].v_Start.x=bns[number].v_Pos.x+bns[number].f_Size*1.5f;
	bns[number].ln[3].v_Start.y=bns[number].v_Pos.y-bns[number].f_Size*1.5f;
	bns[number].ln[3].v_End.x=bns[number].v_Pos.x-bns[number].f_Size*1.5f;
	bns[number].ln[3].v_End.y=bns[number].v_Pos.y-bns[number].f_Size*1.5f;
}

// ===============================================================================================

void Bonus_TestPlayer(const int &number){
	int i,j;
	bool b_BonusDestroy=false;
	bool b_Get=false;
	s_line ln1,ln2;

	ln1.v_Start=plr.v_Pos;
	ln1.v_End=plr.v_Pos+plr.v_Vel*mm.time_Delta/5000.0f;

	//////////////////////////////////////////////////////////////////////////////////////////////
	// Test player for inside bonus
	//////////////////////////////////////////////////////////////////////////////////////////////
	//  ___   
	// | * |   * - player
	// |___|   It is increase accuracy
	//////////////////////////////////////////////////////////////////////////////////////////////
	b_BonusDestroy=(plr.v_Pos.x>=bns[number].v_Pos.x-bns[number].f_Size*2&&
	                plr.v_Pos.y>=bns[number].v_Pos.y-bns[number].f_Size*2&&
					plr.v_Pos.x<=bns[number].v_Pos.x+bns[number].f_Size*2&&
					plr.v_Pos.y<=bns[number].v_Pos.y+bns[number].f_Size*2);

	// Test cross lines between player & wall bonus
	// If player not bonus inside
	if(!b_BonusDestroy)
		for(i=0;i<4;i++){
			ln2.v_Start=bns[number].ln[i].v_Start;
			ln2.v_End=bns[number].ln[i].v_End;

			if(Test_CrossLines(ln1,ln2))
				b_BonusDestroy=true;

		}

	// Case bonus to player
	if(b_BonusDestroy)
	{
		switch(bns[number].i_BonusType){
		case RGS_BONUS_FAST_SPEED:
			if(!plr.bonus_FastSpeed)
				plr.count_Bonuses++;		// If bonuses is not equ previous

			plr.bonus_FastSpeed=true;		// Activate bonus
			plr.f_CurrentFastSpeedTime=0.0f;	// Bonus time - start

			sprintf(rbonus.name,"Bonus fast speed");	// Text to center upper screen
			break;
		case RGS_BONUS_FAST_SHOT:			// Look previous comments
			if(!plr.bonus_FastShot)
				plr.count_Bonuses++;

			plr.bonus_FastShot=true;
			plr.f_CurrentFastShotTime=0.0f;

			sprintf(rbonus.name,"Bonus fast shot");
			break;
		case RGS_BONUS_AK:
			for(j=0;j<plr.count_Weapons;j++)
				if(plr.w_Id[j]==RGS_IDENT_AK)
					b_Get=true;

			if(!b_Get)
				Player_AddWeapon(RGS_IDENT_AK);

			sprintf(rbonus.name,"Bonus AK");
			break;
		case RGS_BONUS_SHOTGUN:
			for(j=0;j<plr.count_Weapons;j++)
				if(plr.w_Id[j]==RGS_IDENT_SHOTGUN)
					b_Get=true;

			if(!b_Get)
				Player_AddWeapon(RGS_IDENT_SHOTGUN);

			sprintf(rbonus.name,"Bonus ShotGun");
			break;
		case RGS_BONUS_GRENADEGUN:
			for(j=0;j<plr.count_Weapons;j++)
				if(plr.w_Id[j]==RGS_IDENT_GRENADE)
					b_Get=true;
			
			if(!b_Get)
				Player_AddWeapon(RGS_IDENT_GRENADE);

			sprintf(rbonus.name,"Bonus GrenadeGun");
			break;
		case RGS_BONUS_HEALTH:
			plr.p_Health+=20.0f;

			if(plr.p_Health>100.0f)
				plr.p_Health=100.0f;

			sprintf(rbonus.name,"Bonus Health +20");
			break;
		case RGS_BONUS_2XSPECIAL:
			if(plr.i_CountSpecial<=16)
				plr.i_CountSpecial*=2;

			sprintf(rbonus.name,"Bonus Special 2x");
			break;
		case RGS_BONUS_100SCORE:
			mm.player_Score+=100.0f;

			sprintf(rbonus.name,"Bonus Score +100");
			break;
		case RGS_BONUS_2XALL:
			if(plr.Weapon[0].count_Patrons == 7)
			{
				plr.Weapon[0].count_Patrons *= 2;
				plr.Weapon[1].count_Patrons *= 2;
				plr.Weapon[2].count_Patrons *= 2;
			}

			sprintf(rbonus.name,"2x max ammo");
			break;
		}

		rbonus.f_Blend=1.0f;
		mm.player_Score+=5.0f;

		OAL_Play(6);

		Bonus_Del(number);
	}
}

// ===============================================================================================

void Bonus_Update(){
	for(int i=0;i<c_Bonus;i++){
		bns[i].f_CurrentTimeLive+=mm.time_Delta;

		if(bns[i].f_CurrentTimeLive>=bns[i].f_AllTimeLive)
			Bonus_Del(i);

		if(bns[i].v_OldPos!=bns[i].v_Pos)
			Bonus_CalculateBoudingLines(i);

		bns[i].v_OldPos=bns[i].v_Pos;

		Bonus_TestPlayer(i);
	}
}

// ===============================================================================================

void Bonus_Render(){
	Bonus_Update();

	glEnable(GL_TEXTURE_2D);

	Texture_CallByName("Textures/Bonus.bmp");

	for(int i=0;i<c_Bonus;i++){
		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,1.0f);

			glTexCoord2d(0.0f,0.0f);
			glVertex2f(bns[i].ln[0].v_Start.x,bns[i].ln[0].v_Start.y);
			glTexCoord2d(0.0f,1.0f);
			glVertex2f(bns[i].ln[1].v_Start.x,bns[i].ln[1].v_Start.y);
			glTexCoord2d(1.0f,1.0f);
			glVertex2f(bns[i].ln[2].v_Start.x,bns[i].ln[2].v_Start.y);
			glTexCoord2d(1.0f,0.0f);
			glVertex2f(bns[i].ln[3].v_Start.x,bns[i].ln[3].v_Start.y);
		glEnd();
	}

	glDisable(GL_TEXTURE_2D);
}

// ===============================================================================================

int GetTextureByName(const char *name){
	for(int i=0;i<c_texture_settings;i++)
		if(!strcmp(name,t_FF[i].name))
			return i;

	return -1;
}

// ===============================================================================================

void Texture_CallByName(const char *name){
	int t_Id=GetTextureByName(name);

	if(t_Id!=-1)
		Texture_Call(t_FF[t_Id].i_Number);
}

// ===============================================================================================

void Texture_Load(const char *fname){
	AUX_RGBImageRec *i_Image=auxDIBImageLoad(fname);
	char *data;
	int i,j;
	int SX,SY;

	c_Textures++;

	// Load texture name in array
	t_FF[c_texture_settings].i_Number=c_Textures;
	strcpy(t_FF[c_texture_settings].name,fname);
	c_texture_settings++;

	SX=i_Image->sizeX;
	SY=i_Image->sizeY;

	data=new char[SX*SY*4];

	for(j=0;j<SY;j++)
		for(i=0;i<SX;i++){
			data[(j*SX+i)*4]=i_Image->data[(j*SX+i)*3];
			data[(j*SX+i)*4+1]=i_Image->data[(j*SX+i)*3+1];
			data[(j*SX+i)*4+2]=i_Image->data[(j*SX+i)*3+2];

			if(i_Image->data[(j*SX+i)*3]==0&&
			   i_Image->data[(j*SX+i)*3+1]==0&&
			   i_Image->data[(j*SX+i)*3+2]==0)
					data[(j*SX+i)*4+3]=0;
			else
				data[(j*SX+i)*4+3]=255;
		}

	glGenTextures(1,&tex[c_Textures]);
	glBindTexture(GL_TEXTURE_2D,tex[c_Textures]);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,i_Image->sizeX,i_Image->sizeY,0,GL_RGBA,GL_UNSIGNED_BYTE,data);

	delete[] data;
}

// ===============================================================================================

void Texture_GenerateGrass(const char *name){
	const int WIDTH_GRASS=512;
	const int HEIGHT_GRASS=512;

	char *mas=new char[WIDTH_GRASS*HEIGHT_GRASS*3];

	c_Textures++;

	t_FF[c_texture_settings].i_Number=c_Textures;
	strcpy(t_FF[c_texture_settings].name,name);
	c_texture_settings++;

	srand(GetTickCount());
	int colorp;
	int typeg=rand()%3;

	for(int j=0;j<HEIGHT_GRASS;j++)
		for(int i=0;i<WIDTH_GRASS;i++){
			switch(typeg){
			case 0:
				colorp=rand()%50+25;
				
				mas[(j*3)*WIDTH_GRASS+(i*3)]=0;
				mas[(j*3)*WIDTH_GRASS+(i*3)+1]=colorp;
				mas[(j*3)*WIDTH_GRASS+(i*3)+2]=0;
				break;
			case 1:
				colorp=rand()%100+50;

				mas[(j*3)*WIDTH_GRASS+(i*3)]=colorp;
				mas[(j*3)*WIDTH_GRASS+(i*3)+1]=colorp;
				mas[(j*3)*WIDTH_GRASS+(i*3)+2]=0;
				break;
			case 2:
				colorp=rand()%100+50;

				mas[(j*3)*WIDTH_GRASS+(i*3)]=colorp;
				mas[(j*3)*WIDTH_GRASS+(i*3)+1]=colorp;
				mas[(j*3)*WIDTH_GRASS+(i*3)+2]=colorp;
				break;
			}
		}

	glGenTextures(1,&tex[c_Textures]);
	glBindTexture(GL_TEXTURE_2D,tex[c_Textures]);

	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);

	glTexImage2D(GL_TEXTURE_2D,0,GL_RGB,WIDTH_GRASS,HEIGHT_GRASS,0,GL_RGB,GL_UNSIGNED_BYTE,mas);

	delete[] mas;
}

// ===============================================================================================

void Texture_Call(int nmb){
	glBindTexture(GL_TEXTURE_2D,tex[nmb]);
}

// ===============================================================================================

void Background_Render(){
	glEnable(GL_TEXTURE_2D);

	Texture_Call(t_FF[GetTextureByName("GreenGrass")].i_Number);

		glBegin(GL_QUADS);
			glColor3f(1.0f,1.0f,1.0f);

			glTexCoord2d(0.0f,0.0f);
			glVertex2f(-1.0f,-1.0f);
			glTexCoord2d(0.0f,1.0f);
			glVertex2f(-1.0f,1.0f);
			glTexCoord2d(1.0f,1.0f);
			glVertex2f(1.0f,1.0f);
			glTexCoord2d(1.0f,0.0f);
			glVertex2f(1.0f,-1.0f);
		glEnd();

	glDisable(GL_TEXTURE_2D);
}

// ===============================================================================================

bool Test_CrossLines(s_line ln1,s_line ln2)
{
/*	float tmp;
	c_vec_2d cp;

	float del_x1=(ln1.v_End.x-ln1.v_Start.x);
	float del_x2=(ln2.v_End.x-ln2.v_Start.x);
	float del_y1=(ln1.v_End.y-ln1.v_Start.y);
	float del_y2=(ln2.v_End.y-ln2.v_Start.y);

	float d1=del_y1/del_x1;
	float d10=(d1*ln1.v_Start.x)-ln1.v_Start.y;
	float d2=del_y2/del_x2;
	float d20=(d2*ln2.v_Start.x)-ln2.v_Start.y;

	if(del_x1==0)
		cp.x=ln1.v_Start.x;
	if(del_x2==0)
		cp.x=ln2.v_Start.x;
	if(del_y1==0)
		cp.y=ln1.v_Start.y;
	if(del_y2==0)
		cp.y=ln2.v_Start.y;

	if(del_x1!=0&&del_x2!=0)
		cp.x=(d20-d10)/(d2-d1);
	if(del_y1!=0&&del_y2!=0)
		cp.y=cp.x*d2-d20;

	if(ln1.v_Start.x>ln1.v_End.x){
		tmp=ln1.v_Start.x;
		ln1.v_Start.x=ln1.v_End.x;
		ln1.v_End.x=tmp;
	}

	if(ln1.v_Start.y>ln1.v_End.y){
		tmp=ln1.v_Start.y;
		ln1.v_Start.y=ln1.v_End.y;
		ln1.v_End.y=tmp;
	}

	if(ln2.v_Start.x>ln2.v_End.x){
		tmp=ln2.v_Start.x;
		ln2.v_Start.x=ln2.v_End.x;
		ln2.v_End.x=tmp;
	}

	if(ln2.v_Start.y>ln2.v_End.y){
		tmp=ln2.v_Start.y;
		ln2.v_Start.y=ln2.v_End.y;
		ln2.v_End.y=tmp;
	}

	if(cp.x>=ln1.v_Start.x&&cp.x<=ln1.v_End.x&&cp.x>=ln2.v_Start.x&&cp.x<=ln2.v_End.x&&
	   cp.y>=ln1.v_Start.y&&cp.y<=ln1.v_End.y&&cp.y>=ln2.v_Start.y&&cp.y<=ln2.v_End.y)
	{
		return true;
	}else
		return false;*/
	float	delx21 = (ln1.v_End.x   - ln1.v_Start.x);
	float	delx31 = (ln2.v_Start.x - ln1.v_Start.x);
	float	delx41 = (ln2.v_End.x   - ln1.v_Start.x);
	float	dely21 = (ln1.v_End.y   - ln1.v_Start.y);
	float	dely31 = (ln2.v_Start.y - ln1.v_Start.y);
	float	dely41 = (ln2.v_End.y   - ln1.v_Start.y);

	float	delx13 = (ln1.v_Start.x - ln2.v_Start.x);
	float	delx23 = (ln1.v_End.x   - ln2.v_Start.x);
	float	delx43 = (ln2.v_End.x   - ln2.v_Start.x);
	float	dely13 = (ln1.v_Start.y - ln2.v_Start.y);
	float	dely23 = (ln1.v_End.y   - ln2.v_Start.y);
	float	dely43 = (ln2.v_End.y   - ln2.v_Start.y);

	float	fv01 = ( delx31 * dely21 - dely31 * delx21) * (delx41 * dely21 - dely41 * delx21 );
	float	fv02 = ( delx13 * dely43 - dely13 * delx43) * (delx23 * dely43 - dely23 * delx43 );

	if( fv01 < 0 && fv02 < 0)
		return		true;
	else
		return		false;
}

// ===============================================================================================

void Bullet_Load(const char *name){
	FILE *infile;

	int ii[3];
	float ff[2];
	char name_m[256];

	infile=fopen(name,"r");

	if(infile){
		fscanf(infile,"%s",&name_m);
		fscanf(infile,"%i %i %i",&ii[0],&ii[1],&ii[2]);
		fscanf(infile,"%f %f",&ff[0],&ff[1]);

		sprintf(b_FF[c_bullet_settings].name,name_m);

		b_FF[c_bullet_settings].b_Explosion=ii[0];
		b_FF[c_bullet_settings].b_Score=ii[1];
		b_FF[c_bullet_settings].f_Damage=ff[0];
		b_FF[c_bullet_settings].f_Speed=ff[1];
		b_FF[c_bullet_settings].i_Random=ii[2];

		c_bullet_settings++;

		fclose(infile);
	}
	else
		MessageBox(mm.hWnd,"File not found","Error",MB_OK);
}

// ===============================================================================================

int GetBulletByName(const char *name){
	for(int i=0;i<c_bullet_settings;i++)
		if(!strcmp(name,b_FF[i].name))
			return i;

	return -1;
}

// ===============================================================================================

void Monster_Load(const char *name){
	FILE *infile;

	int ii;
	float ff[5];
	char name_m[256];

	infile=fopen(name,"r");

	if(infile){
		fscanf(infile,"%s",&name_m);
		sprintf(m_FF[c_monster_settings].name,name_m);

		fscanf(infile,"%i",&ii);
		m_FF[c_monster_settings].i_Score=ii;

		fscanf(infile,"%f %f %f %f %f %f %f %f",&ff[0],&ff[1],&ff[2],&ff[3],&ff[4]);
		m_FF[c_monster_settings].f_Damage=ff[0];
		m_FF[c_monster_settings].f_Health=ff[1];
		m_FF[c_monster_settings].f_Size=ff[2];
		m_FF[c_monster_settings].f_Speed=ff[3];
		m_FF[c_monster_settings].f_ReloadTime=ff[4];

		fscanf(infile,"%s",&name_m);
		sprintf(m_FF[c_monster_settings].namet,name_m);
		m_FF[c_monster_settings].i_Texture=t_FF[GetTextureByName(name_m)].i_Number;

		c_monster_settings++;

		fclose(infile);
	}else
		MessageBox(mm.hWnd,"File not found","Error",MB_OK);
}

// ===============================================================================================

int GetMonsterByName(const char *name){
	for(int j=0;j<c_monster_settings;j++)
		if(!strcmp(name,m_FF[j].name))
			return j;

	return -1;
}

// ===============================================================================================

void Bullet_Respawn(const char *name,const c_vec_2d &pos,const c_vec_2d &dir){
	int b_Id=GetBulletByName(name);

	if(b_Id!=-1){
		s_bullet lblt;

		lblt.b_Pos=pos;
		lblt.b_Vel=dir;

		lblt.b_Vel.vecRotate((rand()%b_FF[b_Id].i_Random-b_FF[b_Id].i_Random/2)/180.0f*RGS_PI);

		lblt.b_Explosion=b_FF[b_Id].b_Explosion;
		lblt.b_Score=b_FF[b_Id].b_Score;
		lblt.b_Speed=b_FF[b_Id].f_Speed;
		lblt.f_Damage=b_FF[b_Id].f_Damage;

		Bullet_Add(lblt);
	}
}

// ===============================================================================================

void Monster_Respawn(const char *name,const c_vec_2d &pos){
	int m_Id=GetMonsterByName(name);

	if(m_Id!=-1){
		s_monster lmst;

		lmst.m_Pos=pos;
		lmst.m_Dir.vecSet(0.0f,1.0f);
		lmst.time_CurrentReload=0.0f;

		lmst.get_Score=m_FF[m_Id].i_Score;

		lmst.m_Damage=m_FF[m_Id].f_Damage;
		lmst.m_Health=m_FF[m_Id].f_Health;
		lmst.m_Size=m_FF[m_Id].f_Size;
		lmst.m_Speed=m_FF[m_Id].f_Speed;
		lmst.time_Reload=m_FF[m_Id].f_ReloadTime;
		lmst.i_Texture=m_FF[m_Id].i_Texture;

		Monster_Add(lmst);
	}
}

// ===============================================================================================

void Monster_Random(const float &radius,const float &time){
	int rand_res,rand_type;
	c_vec_2d dir;

	current_Time+=mm.time_Delta;

	if(mm.f_StartSpeedRespawn!=0.0f)
		mm.f_StartSpeedRespawn-=mm.time_Delta*mm.f_SpeedRespawn;

	if(mm.f_StartSpeedRespawn<=0.0f)
		mm.f_StartSpeedRespawn=0.0f;

	if(current_Time>=mm.f_StartSpeedRespawn&&c_Monsters<1000)
	{
		current_Time=0.0f;

		dir.vecSet(radius,radius);
		dir.vecRotate((rand()%360)/180.0f*3.14f);
		
		rand_type=rand()%3;

		if(mm.f_StartSpeedRespawn>=750.0f)
			rand_res=0;
		else if(mm.f_StartSpeedRespawn>=500.0f&&mm.f_StartSpeedRespawn<=750.0f)
			rand_res=rand()%2;
		else if(mm.f_StartSpeedRespawn<=500.0f)
			rand_res=rand()%3;

		switch(rand_type){
		case 0:
			switch(rand_res){
			case 0:
				Monster_Respawn("MonsterToothSmall",dir);
				break;
			case 1:
				Monster_Respawn("MonsterToothMedium",dir);
				break;
			case 2:
				Monster_Respawn("MonsterToothLarge",dir);
				break;
			}

			break;
		case 1:
			switch(rand_res){
			case 0:
				Monster_Respawn("MonsterZombieSmall",dir);
				break;
			case 1:
				Monster_Respawn("MonsterZombieMedium",dir);
				break;
			case 2:
				Monster_Respawn("MonsterZombieLarge",dir);
				break;
			}

			break;
		case 2:
			switch(rand_res){
			case 0:
				Monster_Respawn("MonsterMindSmall",dir);
				break;
			case 1:
				Monster_Respawn("MonsterMindMedium",dir);
				break;
			case 2:
				Monster_Respawn("MonsterMindLarge",dir);
				break;
			}

			break;
		}
	}
}

// ===============================================================================================

void Monster_Add(const s_monster &monster){
	mst[c_Monsters]=monster;

	mst[c_Monsters].nmb_Anim=c_Animation;
	
	s_animation_sprite sp;

	sp.b_Play=true;
	sp.f_Blend=1.0f;
	sp.f_CurrentTime=0.0f;
	sp.f_Size=mst[c_Monsters].m_Size;
	sp.f_SpeedAnimation=10.0f;
	sp.f_SpeedDestroy=0.0f;
	sp.i_CountFrames=16;
	sp.i_CurrentFrame=0;
	sp.ui_TextureNumber=monster.i_Texture;
	sp.v_Dir=mst[c_Monsters].m_Dir;
	sp.v_Pos=mst[c_Monsters].m_Pos;

	Animation_Add(sp);

	c_Monsters++;
}

// ===============================================================================================

void Monster_TestPlayer(){
	int i;
	float delx,dely,rad;

	mm.f_SoundPlayerDamage+=mm.time_Delta;

	for(i=0;i<c_Monsters;i++){
		delx=(plr.v_Pos.x-mst[i].m_Pos.x);
		dely=(plr.v_Pos.y-mst[i].m_Pos.y);

		rad=sqrt(delx*delx+dely*dely);

		mst[i].time_CurrentReload+=mm.time_Delta;

		if(rad<=0.1f&&mst[i].time_CurrentReload>=mst[i].time_Reload){
			mst[i].time_CurrentReload=0.0f;

			if(!plr.b_Dead){
				plr.p_Health-=mst[i].m_Damage;

				if(mm.f_SoundPlayerDamage>=300.0f)
				{
					OAL_Play(7);

					mm.f_SoundPlayerDamage=0.0f;
				}
			}

			plr.v_Pos+=mst[i].m_Dir/100.0f;
		}
	}
}

// ===============================================================================================

void Monster_Update(){
	int i;
	float rad,delx,dely;

	if(!plr.b_Dead)
		for(i=0;i<c_Monsters;i++)
			mst[i].m_Dir.vecRotate(((mst[i].m_Pos+mst[i].m_Dir)-mst[i].m_Pos).vecCosDot((plr.v_Pos-mst[i].m_Pos).vecNormal()));

	// Calculate bouding lines
	for(i=0;i<c_Monsters;i++){
		mst[i].ln[0].v_Start.x=mst[i].m_Pos.x+mst[i].m_Dir.x*mst[i].m_Size+mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[0].v_Start.y=mst[i].m_Pos.y+mst[i].m_Dir.y*mst[i].m_Size+mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
		mst[i].ln[0].v_End.x=mst[i].m_Pos.x-mst[i].m_Dir.x*mst[i].m_Size+mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[0].v_End.y=mst[i].m_Pos.y-mst[i].m_Dir.y*mst[i].m_Size+mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
		
		mst[i].ln[1].v_Start.x=mst[i].m_Pos.x+mst[i].m_Dir.x*mst[i].m_Size-mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[1].v_Start.y=mst[i].m_Pos.y+mst[i].m_Dir.y*mst[i].m_Size-mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
		mst[i].ln[1].v_End.x=mst[i].m_Pos.x-mst[i].m_Dir.x*mst[i].m_Size-mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[1].v_End.y=mst[i].m_Pos.y-mst[i].m_Dir.y*mst[i].m_Size-mst[i].m_Dir.vecNormal().y*mst[i].m_Size;

		mst[i].ln[2].v_Start.x=mst[i].m_Pos.x+mst[i].m_Dir.x*mst[i].m_Size+mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[2].v_Start.y=mst[i].m_Pos.y+mst[i].m_Dir.y*mst[i].m_Size+mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
		mst[i].ln[2].v_End.x=mst[i].m_Pos.x+mst[i].m_Dir.x*mst[i].m_Size-mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[2].v_End.y=mst[i].m_Pos.y+mst[i].m_Dir.y*mst[i].m_Size-mst[i].m_Dir.vecNormal().y*mst[i].m_Size;

		mst[i].ln[3].v_Start.x=mst[i].m_Pos.x-mst[i].m_Dir.x*mst[i].m_Size+mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[3].v_Start.y=mst[i].m_Pos.y-mst[i].m_Dir.y*mst[i].m_Size+mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
		mst[i].ln[3].v_End.x=mst[i].m_Pos.x-mst[i].m_Dir.x*mst[i].m_Size-mst[i].m_Dir.vecNormal().x*mst[i].m_Size;
		mst[i].ln[3].v_End.y=mst[i].m_Pos.y-mst[i].m_Dir.y*mst[i].m_Size-mst[i].m_Dir.vecNormal().y*mst[i].m_Size;
	}

	s_animation_sprite s;

	for(i=0;i<c_Monsters;i++){
		s.v_Pos=mst[i].m_Pos;
		s.f_Size=mst[i].m_Size;
		s.v_Dir=mst[i].m_Dir.vecNormal();

		Animation_PointsCalculate(mst[i].nmb_Anim,s);
	}

	// Calculate direction monsters
	if(!plr.b_Dead)
	for(i=0;i<c_Monsters;i++){
		delx=plr.v_Pos.x-mst[i].m_Pos.x;
		dely=plr.v_Pos.y-mst[i].m_Pos.y;

		rad=sqrt(delx*delx+dely*dely);

		mst[i].m_Vel.x=(plr.v_Pos.x-mst[i].m_Pos.x)/rad;
		mst[i].m_Vel.y=(plr.v_Pos.y-mst[i].m_Pos.y)/rad;
	}

	for(i=0;i<c_Monsters;i++)
		mst[i].m_Pos+=mst[i].m_Vel*mst[i].m_Speed*mm.time_Delta;

	Monster_TestPlayer();
}

// ===============================================================================================

void Monster_Render(){
	Monster_Update();
}

// ===============================================================================================

void Monster_Del(const int &number){
	int i;
	bool b_Generate=false;

	// Generate bonuse
	if((plr.b_FirstBlood)&&(rand()%10==1))		// If monster is not first
		b_Generate=true;
	else if(!plr.b_FirstBlood)					// If monster first
		b_Generate=true;

	if(b_Generate){
		s_bonus bnss;
	
		bnss.f_AllTimeLive=20000.0f;
		bnss.f_Size=0.025f;

		if(!plr.b_FirstBlood)
			bnss.i_BonusType=202+(rand()%2);
		else
			bnss.i_BonusType=200+(rand()%9);

		bnss.v_Pos=mst[number].m_Pos;
		bnss.v_OldPos.vecZero();
	
		Bonus_Add(bnss);

		plr.b_FirstBlood=true;
	}

	Animation_Del(mst[number].nmb_Anim);

	for(i=number;i<c_Monsters;i++)
		mst[i]=mst[i+1];

	for(i=number;i<c_Monsters;i++)
		mst[i].nmb_Anim--;

	c_Monsters--;
}

// ===============================================================================================

void Setting_Weapon(const int &id,const char *name,const int &c_Patrons,const float &t_Bt,const float &t_R){
	//////////////////////////////////////////////////////////////////////////////////////////////
	// r_id element array of weapon
	// id - constant ident weapon RGS_IDENT_PISTOL, RGS_IDENT_AK and more...
	// 100-100=0(pistol);
	// 104-100=4(grenade gun)
	//////////////////////////////////////////////////////////////////////////////////////////////
	int r_id=id-100;

	sprintf(plr.Weapon[r_id].name,name);	// Copy name from head to array weapon

	plr.Weapon[r_id].count_Patrons=c_Patrons;
	plr.Weapon[r_id].time_BetweenShot=t_Bt;
	plr.Weapon[r_id].time_Reload=t_R;
}

// ===============================================================================================

void Bullet_Add(const s_bullet &bullet){
	blt[c_Bullets]=bullet;

	c_Bullets++;
}

// ===============================================================================================

void Bullet_Del(int nmb){
	for(int i=nmb;i<c_Bullets;i++)
		blt[i]=blt[i+1];

	c_Bullets--;
}

// ===============================================================================================

void Bullet_Explosion(const c_vec_2d &pos,const int &count){
	c_vec_2d dir;

	for(int i=0;i<count;i++){
		dir.vecSet(1.0f,0.0f);

		Bullet_Respawn("BulletGrenadeGunExplosion",pos,dir);
	}
}

// ===============================================================================================

void Standart_ToothDeadSprite(const s_monster &monster){
	s_static_sprite n_Spr;
	s_monster lmonster=monster;

	n_Spr.f_Blend=1.0f;
	n_Spr.f_Size=lmonster.m_Size;
	n_Spr.f_SpeedDestroy=0.00005f;
	if(lmonster.i_Texture==t_FF[GetTextureByName("Textures/Tooth.bmp")].i_Number)
		n_Spr.ui_TextureNumber=t_FF[GetTextureByName("Textures/Tooth_Dead.bmp")].i_Number;
	if(lmonster.i_Texture==t_FF[GetTextureByName("Textures/Zombie.bmp")].i_Number)
		n_Spr.ui_TextureNumber=t_FF[GetTextureByName("Textures/Zombie_Dead.bmp")].i_Number;
	if(lmonster.i_Texture==t_FF[GetTextureByName("Textures/Mind.bmp")].i_Number)
		n_Spr.ui_TextureNumber=t_FF[GetTextureByName("Textures/Mind_Dead.bmp")].i_Number;
	n_Spr.v_Pos=lmonster.m_Pos;
	n_Spr.v_Dir=lmonster.m_Dir.vecNormal();

	Sprite_Add(n_Spr);
}

// ===============================================================================================

void Particle_Load(const char *name){
	FILE *infile;
	char name_m[256];
	int ii;
	float ff[7];

	infile=fopen(name,"r");

	if(infile){
		fscanf(infile,"%s",&name_m);

		fscanf(infile,"%i",&ii);

		fscanf(infile,"%f %f %f %f %f %f %f",&ff[0],&ff[1],&ff[2],&ff[3],&ff[4],&ff[5],&ff[6]);

		strcpy(FF_par[c_particle_settings].name,name_m);
		FF_par[c_particle_settings].i_Scatter=ii;
		FF_par[c_particle_settings].f_Blend=ff[0];
		FF_par[c_particle_settings].f_SpeedDestroy=ff[1];
		FF_par[c_particle_settings].f_SpeedMove=ff[2];
		FF_par[c_particle_settings].f_Resistance=ff[3];
		FF_par[c_particle_settings].f_R=ff[4];
		FF_par[c_particle_settings].f_G=ff[5];
		FF_par[c_particle_settings].f_B=ff[6];

		c_particle_settings++;

		fclose(infile);
	}
}

// ===============================================================================================

int GetParticleByName(const char *name){
	for(int i=0;i<c_particle_settings;i++)
		if(!strcmp(name,FF_par[i].name))
			return i;

	return -1;
}

// ===============================================================================================

void Particle_Respawn(const char *name,c_vec_2d &pos,c_vec_2d &dir){
	int p_Id=GetParticleByName(name);

	if(p_Id!=-1){
		s_particle lptr;

		lptr.f_Blend=FF_par[p_Id].f_Blend;
		lptr.f_Resistance=FF_par[p_Id].f_Resistance;
		lptr.f_SpeedDestroy=FF_par[p_Id].f_SpeedDestroy;
		lptr.f_SpeedMove=FF_par[p_Id].f_SpeedMove;
		
		lptr.i_AngleScatter=FF_par[p_Id].i_Scatter;

		lptr.p_color.r=FF_par[p_Id].f_R;
		lptr.p_color.g=FF_par[p_Id].f_G;
		lptr.p_color.b=FF_par[p_Id].f_B;

		lptr.v_Pos=pos;
		lptr.v_Dir=dir;

		Particle_Add(lptr);
	}
}

// ===============================================================================================

void Standart_BloodSprite(const c_vec_2d &pos){
	s_static_sprite n_Spr;

	n_Spr.f_Blend=1.0f;
	n_Spr.f_Size=(rand()%100+50)/2000.0f;
	n_Spr.f_SpeedDestroy=0.00005f;
	n_Spr.ui_TextureNumber=t_FF[GetTextureByName("Textures/Blood.bmp")].i_Number;
	n_Spr.v_Pos=pos;
	// Random radius
	n_Spr.v_Pos.x+=(rand()%100-50)/1000.0f;
	n_Spr.v_Pos.y+=(rand()%100-50)/1000.0f;
	// ->
	n_Spr.v_Dir=c_vec_2d(0.0f,1.0f);
	n_Spr.v_Dir.vecRotate((rand()%360)/180.0f*RGS_PI);

	Sprite_Add(n_Spr);
}

// ===============================================================================================

void Standart_ExplosionSpotSprite(const c_vec_2d &pos){
	s_static_sprite n_Spr;

	n_Spr.f_Blend=0.5f;
	n_Spr.f_Size=0.1f;
	n_Spr.f_SpeedDestroy=0.00005f;
	n_Spr.ui_TextureNumber=t_FF[GetTextureByName("Textures/Spot_Explosion.bmp")].i_Number;
	n_Spr.v_Pos=pos;
	n_Spr.v_Dir=c_vec_2d(0.0f,1.0f);
	n_Spr.v_Dir.vecRotate((rand()%360)/180.0f*RGS_PI);

	Sprite_Add(n_Spr);
}

// ===============================================================================================

void Bullet_Test(){
	int i,j,k;

	for(i=0;i<c_Bullets;i++)
		if(blt[i].b_Pos.x>1.0f||blt[i].b_Pos.x<-1||blt[i].b_Pos.y>1||blt[i].b_Pos.y<-1)
			Bullet_Del(i);

	s_line line_s;
	bool kill_True;

	mm.f_SoundDamage+=mm.time_Delta;

	for(j=0;j<c_Monsters;j++){
		for(i=0;i<c_Bullets;i++){
			line_s.v_Start=blt[i].b_Pos;
			line_s.v_End=(blt[i].b_Pos+blt[i].b_Vel*blt[i].b_Speed*mm.time_Delta);

			kill_True=false;

			for(k=0;k<4;k++)
				if(Test_CrossLines(mst[j].ln[k],line_s))
					kill_True=true;

			if(kill_True){
				if(plr.current_Weapon==3&&blt[i].b_Explosion){
					Standart_ExplosionSpotSprite(mst[j].m_Pos);
					Bullet_Explosion(mst[j].m_Pos,16);

					s_animation_sprite anis;

					anis.b_Play=true;
					anis.f_Blend=1.0f;
					anis.f_CurrentTime=0.0f;
					anis.f_Size=0.2f;
					anis.f_SpeedAnimation=20.0f;
					anis.f_SpeedDestroy=0.001f;
					anis.i_CountFrames=16;
					anis.i_CurrentFrame=0;
					anis.ui_TextureNumber=t_FF[GetTextureByName("Textures/Explosion.bmp")].i_Number;
					anis.v_Dir.vecSet(1.0f,0.0f);
					anis.v_Pos=mst[j].m_Pos;

					Animation_Add(anis);

					OAL_Play(5);
				}

				mst[j].m_Health-=blt[i].f_Damage;
				mst[j].m_Pos+=blt[i].b_Vel/50.0f;
				
				if(mm.f_SoundDamage>=200.0f){
					OAL_Play(4);
					mm.f_SoundDamage=0.0f;
				}
				
				if(mst[j].m_Health<=0){
					for(k=0;k<2;k++)
						Standart_BloodSprite(mst[j].m_Pos);

					Standart_ToothDeadSprite(mst[j]);

					if(blt[i].b_Score)
						mm.player_Score+=mst[j].get_Score;

					Monster_Del(j);
				}else
					Standart_BloodSprite(mst[j].m_Pos);

				Bullet_Del(i);
			}
		}
	}
}

// ===============================================================================================

void Bullet_Update(){
	for(int i=0;i<c_Bullets;i++){
		blt[i].b_Pos+=blt[i].b_Vel*blt[i].b_Speed*mm.time_Delta;

		if(blt[i].b_Explosion&&!mm.game_BuyMenu)
			Particle_Respawn("ParticleSparkRocket",blt[i].b_Pos,c_vec_2d(-blt[i].b_Vel.x,-blt[i].b_Vel.y));
	}

	Bullet_Test();
}

// ===============================================================================================

void Bullet_Render(){
	Bullet_Update();

	glLineWidth(1.0f);

	glEnable(GL_POINT_SMOOTH);

	glPointSize(2.0f);

	for(int i=0;i<c_Bullets;i++){
		glBegin(GL_LINES);
			glColor4f(1.0f,1.0f,1.0f,0.0f);
			glVertex2f(blt[i].b_Pos.x,blt[i].b_Pos.y);
			glColor4f(1.0f,1.0f,1.0f,1.5f);
			glVertex2f(blt[i].b_Pos.x+blt[i].b_Vel.x*blt[i].b_Speed*mm.time_Delta,blt[i].b_Pos.y+blt[i].b_Vel.y*blt[i].b_Speed*mm.time_Delta);
		glEnd();

		glBegin(GL_POINTS);
			glVertex2f(blt[i].b_Pos.x+blt[i].b_Vel.x*blt[i].b_Speed*mm.time_Delta,blt[i].b_Pos.y+blt[i].b_Vel.y*blt[i].b_Speed*mm.time_Delta);
		glEnd();
	}

	glDisable(GL_POINT_SMOOTH);
}

// ===============================================================================================

void Text_BuildFont(const char *name,const int &width,const int &height,const int number){
	HFONT fnt;

	mm.text_Base[number]=glGenLists(96);

	fnt=CreateFont(width,height,0,0,FW_BOLD,0,0,0,0,0,0,0,0,name);

	SelectObject(mm.hDc,fnt);
	wglUseFontBitmaps(mm.hDc,32,96,mm.text_Base[number]);
}

// ===============================================================================================

void Text_Printf(const int number,const float &x,const float &y,const char *text,...){
	char t_text[256];
	va_list va;

	va_start(va,text);
		vsprintf(t_text,text,va);
	va_end(va);

	glListBase(mm.text_Base[number]-32);

	glRasterPos2f(x,y);
	glCallLists(strlen(t_text),GL_UNSIGNED_BYTE,t_text);
}

// ===============================================================================================

void SetDCPixelFormat(HDC hDc){
	PIXELFORMATDESCRIPTOR pfd;
	int nPixelFormat;

	memset(&pfd,0,sizeof(PIXELFORMATDESCRIPTOR));
	pfd.dwFlags=PFD_DRAW_TO_WINDOW|PFD_SUPPORT_OPENGL|PFD_DOUBLEBUFFER;
	nPixelFormat=ChoosePixelFormat(mm.hDc,&pfd);
	SetPixelFormat(mm.hDc,nPixelFormat,&pfd);
}

// ===============================================================================================

void Player_Update(){
	plr.p_RunPower+=plr.f_RecoverPowerRunSpeed*mm.time_Delta;

	if(plr.bonus_FastSpeed)
		plr.f_CurrentFastSpeedTime+=mm.time_Delta;
	if(plr.bonus_FastShot)
		plr.f_CurrentFastShotTime+=mm.time_Delta;

	if(plr.f_CurrentFastSpeedTime>=RGS_MAX_FAST_SPEED_TIME){
		plr.bonus_FastSpeed=false;
		plr.count_Bonuses--;

		plr.f_CurrentFastSpeedTime=0.0f;
	}
	if(plr.f_CurrentFastShotTime>=RGS_MAX_FAST_SHOT_TIME){
		plr.bonus_FastShot=false;
		plr.count_Bonuses--;

		plr.f_CurrentFastShotTime=0.0f;
	}

	if(plr.p_RunPower>=100.0f)
		plr.p_RunPower=100.0f;
}

void Player_Tracing(){
	plr.f_CurrentTraceTime+=mm.time_Delta;

	if(plr.f_CurrentTraceTime>=plr.f_TimeBetweenTrace){
		s_static_sprite sp;

		sp.f_Blend=0.5f;
		sp.f_Size=0.05f;
		sp.f_SpeedDestroy=plr.f_SpeedDestroyTrace;
		sp.ui_TextureNumber=t_FF[GetTextureByName("Textures/MarineBlur.bmp")].i_Number;
		sp.v_Dir=plr.v_Dir.vecNormal();
		sp.v_Pos=plr.v_Pos;

		Sprite_Add(sp);

		plr.f_CurrentTraceTime=0.0f;
	}
}

// ===============================================================================================

void Player_Render(){
	Player_Update();

	glPointSize(10.0f);

	glEnable(GL_TEXTURE_2D);

	Texture_Call(t_FF[GetTextureByName("Textures/Cell.bmp")].i_Number);

	glBegin(GL_QUADS);
		glColor3f(1.0f,1.0f,1.0f);

		glTexCoord2d(0.0f,0.0f);
		glVertex2f(mm.fm_Pos.x-0.035f,mm.fm_Pos.y-0.035f);
		glTexCoord2d(0.0f,1.0f);
		glVertex2f(mm.fm_Pos.x-0.035f,mm.fm_Pos.y+0.035f);
		glTexCoord2d(1.0f,1.0f);
		glVertex2f(mm.fm_Pos.x+0.035f,mm.fm_Pos.y+0.035f);
		glTexCoord2d(1.0f,0.0f);
		glVertex2f(mm.fm_Pos.x+0.035f,mm.fm_Pos.y-0.035f);
	glEnd();

	glDisable(GL_TEXTURE_2D);

	plr.v_Dir.vecRotate(((plr.v_Pos+plr.v_Dir)-plr.v_Pos).vecCosDot((mm.fm_Pos-plr.v_Pos).vecNormal()));

	glLineWidth(2.0f);

	glBegin(GL_LINES);
		glColor4f(1.0f,0.0f,0.0f,1.0f);
		glVertex2f(plr.v_Pos.x+plr.v_Dir.x/25,plr.v_Pos.y+plr.v_Dir.y/25);
		glColor4f(1.0f,0.0f,0.0f,0.0f);
		glVertex2f(plr.v_Pos.x+plr.v_Dir.x,plr.v_Pos.y+plr.v_Dir.y);
	glEnd();

	glLineWidth(1.0f);

	// Player blur when active bonus fast speed
	if(plr.bonus_FastSpeed)
		Player_Tracing();
}

// ===============================================================================================

void Player_AddWeapon(const int &id){
	plr.w_Id[plr.count_Weapons]=id;
	int r_id=id-100;	// If you don't understand see function Setting_Weapon

	plr.Weapon[r_id].count_InLoad=plr.Weapon[r_id].count_Patrons;

	plr.count_Weapons++;
}

// ===============================================================================================

void OAL_TestPlay(){
	ALenum state;

	for(int i=0;i<c_SoundBuffers;i++){
		alGetSourcei(sndb[i],AL_SOURCE_STATE,&state);
	
		if(state!=AL_PLAYING){
			alDeleteSources(1,&sndb[i]);

			for(int j=i;j<c_SoundBuffers;j++)
				sndb[j]=sndb[j+1];

			c_SoundBuffers--;
		}
	}
}

void Shot_Test(){
	c_vec_2d v_ShotGun;
	int i;

	if(plr.bonus_FastShot)
		plr.f_CurrentShotTime+=mm.time_Delta*2;
	else
		plr.f_CurrentShotTime+=mm.time_Delta;

	if(mm.lbtn&&plr.f_CurrentShotTime>=plr.Weapon[plr.current_Weapon].time_BetweenShot&&mm.speed_Game)
		if(plr.Weapon[plr.current_Weapon].count_InLoad>0){
			plr.f_CurrentShotTime=0.0f;

			Particle_Respawn("ParticlePistol",plr.v_Pos+plr.v_Dir/25,plr.v_Dir.vecNormal());

			// Sparks for shoot
			for(i=0;i<3;i++)
				Particle_Respawn("ParticleShot",plr.v_Pos+plr.v_Dir/25,plr.v_Dir);
	
			// Shoot from weapons
			switch(plr.current_Weapon){
			case 0:			// Shoot from pistol
				Bullet_Respawn("BulletPistol",plr.v_Pos,plr.v_Dir);
				OAL_Play(0);
				break;
			case 1:			// Shoot from Automat Kalashnikov
				Bullet_Respawn("BulletAK",plr.v_Pos,plr.v_Dir);
				OAL_Play(1);
				break;
			case 2:			// Shoot from shotgun
				for(i=0;i<RGS_COUNT_BUL_SHOTGUN;i++)
					Bullet_Respawn("BulletShotGun",plr.v_Pos+(plr.v_Dir*i)/75.0f,plr.v_Dir);

				OAL_Play(2);
				break;
			case 3:			// Shoot from grenade gun
				Bullet_Respawn("BulletGrenadeGun",plr.v_Pos,plr.v_Dir);
				OAL_Play(3);
				break;
			}

			plr.Weapon[plr.current_Weapon].count_InLoad--;
		}

	if(plr.Weapon[plr.current_Weapon].count_InLoad<=0)
	{
		if(plr.bonus_FastShot)
			plr.f_CurrentReloadWeaponTime+=mm.time_Delta*2;
		else
			plr.f_CurrentReloadWeaponTime+=mm.time_Delta;

		if(plr.f_CurrentReloadWeaponTime>=plr.Weapon[plr.current_Weapon].time_Reload)
		{
			plr.f_CurrentReloadWeaponTime=0.0f;	
			plr.Weapon[plr.current_Weapon].count_InLoad+=plr.Weapon[plr.current_Weapon].count_Patrons;
		}
	}

	OAL_TestPlay();
}

// ===============================================================================================

void Mouse_Test(){
	GetCursorPos(&mm.m_Pos);

	mm.fm_Pos.x=-1+(float(mm.m_Pos.x)/(mm.sc_Width/2));
	mm.fm_Pos.y=1-(float(mm.m_Pos.y)/(mm.sc_Height/2));
}

// ===============================================================================================

void RedGutS_ProcessKeys(){
	bool b_PlayerWalk=false;

	Mouse_Test();

	Shot_Test();

	plr.v_DirMove.vecZero();

	if(mm.keys[VK_UP]||mm.keys['W']){
		plr.v_DirMove+=c_vec_2d(0.0f,1.0f);
		b_PlayerWalk=true;
	}
	if(mm.keys[VK_DOWN]||mm.keys['S']){
		plr.v_DirMove-=c_vec_2d(0.0f,1.0f);
		b_PlayerWalk=true;
	}
	if(mm.keys[VK_LEFT]||mm.keys['A']){
		plr.v_DirMove-=c_vec_2d(1.0f,0.0f);
		b_PlayerWalk=true;
	}
	if(mm.keys[VK_RIGHT]||mm.keys['D']){
		plr.v_DirMove+=c_vec_2d(1.0f,0.0f);
		b_PlayerWalk=true;
	}

	// Result addition velocity
	c_vec_2d vel_result=plr.v_Vel;

	ani[plr.i_NumberAnimation].f_SpeedAnimation=20;

	if(mm.keys[VK_SHIFT]){
		if(b_PlayerWalk){
			plr.p_RunPower-=mm.time_Delta/50.0f;

			if(plr.p_RunPower>1.0f){
				vel_result*=2.0f;

				ani[plr.i_NumberAnimation].f_SpeedAnimation*=2;
			}
		}

		if(plr.p_RunPower<=0.0f)
			plr.p_RunPower=0.0f;
	}

	float angle=plr.v_DirMove.vecNormal().vecDot(plr.v_Vel);

	if(!angle)
		angle=0.0001f;

	if(plr.bonus_FastSpeed)
		vel_result*=2.0f;

	if(b_PlayerWalk){
		plr.v_Vel.vecRotate(angle/fabs(angle)/15.0f);

		plr.v_Pos+=vel_result*mm.time_Delta/5000.0f;
	}

	if(plr.v_Pos.x<=-1)
		plr.v_Pos.x=-1;
	if(plr.v_Pos.x>=1)
		plr.v_Pos.x=1;
	if(plr.v_Pos.y<=-1)
		plr.v_Pos.y=-1;
	if(plr.v_Pos.y>=1)
		plr.v_Pos.y=1;

	// Animation player
	ani[plr.i_NumberAnimation].b_Play=b_PlayerWalk;

	ani[plr.i_NumberAnimation].v_Pos=plr.v_Pos;
	ani[plr.i_NumberAnimation].v_Dir=plr.v_Dir.vecNormal();
	
	Animation_PointsCalculate(plr.i_NumberAnimation,ani[plr.i_NumberAnimation]);

	// ---
	c_vec_2d vel;

	plr.f_CurrentSpecialTime+=mm.time_Delta;

	if(mm.rbtn&&plr.f_CurrentSpecialTime>=1000&&mm.player_Score>=100&&mm.speed_Game){
		for(int i=0;i<plr.i_CountSpecial;i++){
			vel.x=cos(i*360/180.0f*3.14/plr.i_CountSpecial);
			vel.y=sin(i*360/180.0f*3.14/plr.i_CountSpecial);

			Bullet_Respawn("BulletCirclePlayer",plr.v_Pos,vel);
		}

		OAL_Play(9);

		mm.player_Score-=100;
		plr.f_CurrentSpecialTime=false;
	}
}

// ===============================================================================================

void OAL_Init(){
	mm.pDevice=alcOpenDevice(NULL);
	mm.pContext=alcCreateContext(mm.pDevice,NULL);
	alcMakeContextCurrent(mm.pContext);
}

// ===============================================================================================

void OAL_LoadWav(char *name){
	int format;
	void *data;
	unsigned int size;
	unsigned int freq;
	char loop;

	alGenBuffers(1,&snd[c_SoundBuffers]);
	alutLoadWAVFile(name,&format,&data,&size,&freq,&loop);
	alBufferData(snd[c_SoundBuffers],format,data,size,freq);
	alutUnloadWAV(format,data,size,freq);

	c_SoundBuffers++;
}

// ===============================================================================================

void OAL_Play(int number){
	alGenSources(1,&sndb[c_SoundBuffers]);
	alSourcei(sndb[c_SoundBuffers],AL_BUFFER,snd[number]);

	alSourcePlay(sndb[c_SoundBuffers]);

	c_SoundBuffers++;
}

// ===============================================================================================

void RedGutS_Init(){
	srand(GetTickCount());

	mm.hDc=GetDC(mm.hWnd);

	SetDCPixelFormat(mm.hDc);
	mm.hRc=wglCreateContext(mm.hDc);

	ShowCursor(false);

	wglMakeCurrent(mm.hDc,mm.hRc);

	switch(mm.sc_Width)
	{
	case 800:
		Text_BuildFont("Courier new",12,12,0);
		Text_BuildFont("Courier new",23,23,1);
		break;
	case 640:
		Text_BuildFont("Courier new",8,8,0);
		Text_BuildFont("Courier new",18,18,1);
		break;
	default:
		Text_BuildFont("Courier new",15,15,0);
		Text_BuildFont("Courier new",30,30,1);
		break;
	}

	Texture_GenerateGrass("GreenGrass");
	Texture_Load("Textures/Cell.bmp");
	Texture_Load("Textures/Marine.bmp");
	Texture_Load("Textures/Zombie.bmp");
	Texture_Load("Textures/Mind.bmp");
	Texture_Load("Textures/Blood.bmp");
	Texture_Load("Textures/Tooth.bmp");
	Texture_Load("Textures/Zombie_Dead.bmp");
	Texture_Load("Textures/Mind_Dead.bmp");
	Texture_Load("Textures/Tooth_Dead.bmp");
	Texture_Load("Textures/Spot_Explosion.bmp");
	Texture_Load("Textures/Explosion.bmp");
	Texture_Load("Textures/Bonus.bmp");
	Texture_Load("Textures/RedGutSLogo.bmp");
	Texture_Load("Textures/MarineBlur.bmp");
	Texture_Load("Textures/MarineDead.bmp");

	New_Game();

	// Load sounds
	OAL_Init();
	OAL_LoadWav("Sounds/PistolShot.wav");
	OAL_LoadWav("Sounds/AKShot.wav");
	OAL_LoadWav("Sounds/ShotGun.wav");
	OAL_LoadWav("Sounds/GrenadeGun.wav");
	OAL_LoadWav("Sounds/Damage.wav");
	OAL_LoadWav("Sounds/Explosion.wav");
	OAL_LoadWav("Sounds/PickUp.wav");
	OAL_LoadWav("Sounds/MarineHm.wav");
	OAL_LoadWav("Sounds/MarineDeath.wav");
	OAL_LoadWav("Sounds/Special.wav");

	// Load monsters from file
	Monster_Load("Monsters/MonsterZombieSmall.mst");
	Monster_Load("Monsters/MonsterZombieMedium.mst");
	Monster_Load("Monsters/MonsterZombieLarge.mst");
	Monster_Load("Monsters/MonsterToothSmall.mst");
	Monster_Load("Monsters/MonsterToothMedium.mst");
	Monster_Load("Monsters/MonsterToothLarge.mst");
	Monster_Load("Monsters/MonsterMindSmall.mst");
	Monster_Load("Monsters/MonsterMindMedium.mst");
	Monster_Load("Monsters/MonsterMindLarge.mst");

	// Load bullets from file
	Bullet_Load("Bullets/BulletPistol.blt");
	Bullet_Load("Bullets/BulletAK.blt");
	Bullet_Load("Bullets/BulletShotGun.blt");
	Bullet_Load("Bullets/BulletGrenadeGun.blt");
	Bullet_Load("Bullets/BulletGrenadeGunExplosion.blt");
	Bullet_Load("Bullets/BulletCirclePlayer.blt");

	// Load partiles from file
	Particle_Load("Particles/ParticlePistol.prt");
	Particle_Load("Particles/ParticleSparkRocket.prt");
	Particle_Load("Particles/ParticleShot.prt");

	// Blend settings
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	mm.game_BuyMenu=true;
}

// ===============================================================================================

void LineProcess_Render(const c_vec_2d &start,const c_vec_2d &end,const float &per){
	float delx,dely;

	delx=(end.x-start.x)/100.0f;
	dely=(end.y-start.y)/100.0f;

	glBegin(GL_LINES);
		glVertex2f(start.x,start.y);
		glVertex2f(start.x+per*delx,start.y+per*dely);
	glEnd();
}

// ===============================================================================================

void GameMenu_Render(){
	mm.select_nmb=0;

	glColor4f(0.25f,0.25f,0.25f,0.75f);

	glBegin(GL_QUADS);
		glVertex2f(-0.975f,0.935f);
		glVertex2f(-0.975f,0.675f-plr.count_Bonuses/25.0f);
		glVertex2f(-0.5f,0.675f-plr.count_Bonuses/25.0f);
		glVertex2f(-0.5f,0.935f);
	glEnd();

	glColor4f(0.45f,0.45f,0.45f,0.75f);

	glLineWidth(3.0f);

	glBegin(GL_LINE_LOOP);
		glVertex2f(-0.975f,0.935f);
		glVertex2f(-0.975f,0.675f-plr.count_Bonuses/25.0f);
		glVertex2f(-0.5f,0.675f-plr.count_Bonuses/25.0f);
		glVertex2f(-0.5f,0.935f);
	glEnd();

	glLineWidth(2.0f);

	glBegin(GL_LINES);
		glVertex2f(-0.95f,0.75f);
		glVertex2f(-0.525f,0.75f);
	glEnd();

	glLineWidth(5.0f);

	glColor4f(1.0f-plr.p_RunPower/100.0f,0.0f,plr.p_RunPower/100.0f,0.5f);

	LineProcess_Render(c_vec_2d(-0.675f,0.71f),c_vec_2d(-0.525f,0.71f),plr.p_RunPower);

	glColor4f(1.0f,1.0f,1.0f,1.0f);
	
	Text_Printf(0,-0.95f,0.9f,plr.Weapon[plr.current_Weapon].name);
	Text_Printf(0,-0.69f,0.9f,"%d",plr.Weapon[plr.current_Weapon].count_InLoad);
	Text_Printf(0,-0.95f,0.85f,"Health     %3.1f",plr.p_Health);
	Text_Printf(0,-0.95f,0.8f,"Score      %i",mm.player_Score);
	Text_Printf(0,-0.95f,0.7f,"Run power");

	int cur=0;

	if(plr.bonus_FastSpeed){
		cur++;

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		Text_Printf(0,-0.95f,0.7f-(cur)/25.0f,"Fast Speed");

		glColor4f(1.0f-(RGS_MAX_FAST_SPEED_TIME-plr.f_CurrentFastSpeedTime)/RGS_MAX_FAST_SPEED_TIME,
			      0.0f,(RGS_MAX_FAST_SPEED_TIME-plr.f_CurrentFastSpeedTime)/RGS_MAX_FAST_SPEED_TIME,0.5f);
		LineProcess_Render(c_vec_2d(-0.675f,0.71f-cur/25.0f),
			               c_vec_2d(-0.525f,0.71f-cur/25.0f),
						   (RGS_MAX_FAST_SPEED_TIME-plr.f_CurrentFastSpeedTime)/(RGS_MAX_FAST_SPEED_TIME/100.0f));
	}
	if(plr.bonus_FastShot){
		cur++;

		glColor4f(1.0f,1.0f,1.0f,1.0f);
		Text_Printf(0,-0.95f,0.7f-(cur)/25.0f,"Fast Shot");

		glColor4f(1.0f-(RGS_MAX_FAST_SHOT_TIME-plr.f_CurrentFastShotTime)/RGS_MAX_FAST_SHOT_TIME,
			      0.0f,(RGS_MAX_FAST_SHOT_TIME-plr.f_CurrentFastShotTime)/RGS_MAX_FAST_SHOT_TIME,0.5f);
		LineProcess_Render(c_vec_2d(-0.675f,0.71f-cur/25.0f),
			               c_vec_2d(-0.525f,0.71f-cur/25.0f),
						   (RGS_MAX_FAST_SHOT_TIME-plr.f_CurrentFastShotTime)/(RGS_MAX_FAST_SHOT_TIME/100.0f));
	}

	if(mm.game_BuyMenu){
		if(mm.fm_Pos.x>0.1f&&mm.fm_Pos.x<0.6f&&mm.fm_Pos.y<0.0f&&mm.fm_Pos.y>-0.15f)
			mm.select_nmb=1;
		if(mm.fm_Pos.x>0.15f&&mm.fm_Pos.x<0.6f&&mm.fm_Pos.y<-0.16f&&mm.fm_Pos.y>-0.31f)
			mm.select_nmb=2;
		if(mm.fm_Pos.x>0.1f&&mm.fm_Pos.x<0.6f&&mm.fm_Pos.y<-0.32f&&mm.fm_Pos.y>-0.47f)
			mm.select_nmb=3;

		glDisable(GL_BLEND);

		glEnable(GL_TEXTURE_2D);

		Texture_CallByName("Textures/RedGutSLogo.bmp");

		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,1.0f);

			glTexCoord2d(0.0f,0.0f);
			glVertex2f(-1.0f,-1.0f);
			glTexCoord2d(0.0f,1.0f);
			glVertex2f(-1.0f,1.0f);
			glTexCoord2d(1.0f,1.0f);
			glVertex2f(1.0f,1.0f);
			glTexCoord2d(1.0f,0.0f);
			glVertex2f(1.0f,-1.0f);
		glEnd();

		glDisable(GL_TEXTURE_2D);

		glEnable(GL_BLEND);

		if(mm.select_nmb==1)
			glColor4f(0.0f,0.75f,0.0f,0.75f);
		else
			glColor4f(0.0f,0.75f,0.0f,0.5f);

		glBegin(GL_QUADS);
			glVertex2f(0.05f,-0.0f);
			glVertex2f(0.15f,-0.15f);
			glVertex2f(0.6f,-0.15f);
			glVertex2f(0.6f,-0.0f);
		glEnd();

		if(mm.select_nmb==2)
			glColor4f(0.0f,0.75f,0.0f,0.75f);
		else
			glColor4f(0.0f,0.75f,0.0f,0.5f);

		glBegin(GL_QUADS);
			glVertex2f(0.15f,-0.16f);
			glVertex2f(0.15f,-0.31f);
			glVertex2f(0.6f,-0.31f);
			glVertex2f(0.6f,-0.16f);
		glEnd();

		if(mm.select_nmb==3)
			glColor4f(0.0f,0.75f,0.0f,0.75f);
		else
			glColor4f(0.0f,0.75f,0.0f,0.5f);

		glBegin(GL_QUADS);
			glVertex2f(0.15f,-0.32f);
			glVertex2f(0.05f,-0.47f);
			glVertex2f(0.6f,-0.47f);
			glVertex2f(0.6f,-0.32f);
		glEnd();

		glLineWidth(3.0f);

		glColor4f(0.0f,0.75f,0.0f,0.5f);

		glBegin(GL_LINE_LOOP);
			glVertex2f(0.05f,-0.0f);
			glVertex2f(0.15f,-0.15f);
			glVertex2f(0.6f,-0.15f);
			glVertex2f(0.6f,-0.0f);
		glEnd();

		glBegin(GL_LINE_LOOP);
			glVertex2f(0.15f,-0.16f);
			glVertex2f(0.15f,-0.31f);
			glVertex2f(0.6f,-0.31f);
			glVertex2f(0.6f,-0.16f);
		glEnd();

		glBegin(GL_LINE_LOOP);
			glVertex2f(0.15f,-0.32f);
			glVertex2f(0.05f,-0.47f);
			glVertex2f(0.6f,-0.47f);
			glVertex2f(0.6f,-0.32f);
		glEnd();

		glBegin(GL_LINES);
			glColor4f(1.0f,0.0f,0.0f,1.0f);
			glVertex2f(-1.0f,0.85f);
			glColor4f(1.0f,0.0f,0.0f,0.0f);
			glVertex2f(1.0f,0.85f);
		glEnd();

		glColor4f(1.0f,1.0f,1.0f,0.75f);
		Text_Printf(1,0.125f,-0.09f,"New Game");
		glColor4f(1.0f,1.0f,1.0f,0.75f);
		Text_Printf(1,0.18f,-0.25f,"Credits");
		glColor4f(1.0f,1.0f,1.0f,0.75f);
		Text_Printf(1,0.125f,-0.41f,"Exit Win");

		glEnable(GL_TEXTURE_2D);

		Texture_CallByName("Textures/Cell.bmp");

		glBegin(GL_QUADS);
			glColor4f(1.0f,1.0f,1.0f,1.0f);

			glTexCoord2d(0.0f,0.0f);
			glVertex2f(-0.03f+mm.fm_Pos.x,-0.03f+mm.fm_Pos.y);
			glTexCoord2d(0.0f,1.0f);
			glVertex2f(-0.03f+mm.fm_Pos.x,0.03f+mm.fm_Pos.y);
			glTexCoord2d(1.0f,1.0f);
			glVertex2f(0.03f+mm.fm_Pos.x,0.03f+mm.fm_Pos.y);
			glTexCoord2d(1.0f,0.0f);
			glVertex2f(0.03f+mm.fm_Pos.x,-0.03f+mm.fm_Pos.y);
		glEnd();

		glDisable(GL_TEXTURE_2D);

		if(mm.b_score)
		{
			glColor4f(1.0f,1.0f,1.0f,0.5f);

			glBegin(GL_QUADS);
				glVertex2f(-0.8f,0.8f);
				glVertex2f(-0.8f,0.0f);
				glVertex2f(-0.0f,0.0f);
				glVertex2f(-0.0f,0.8f);
			glEnd();

			glBegin(GL_LINE_LOOP);
				glVertex2f(-0.8f,0.8f);
				glVertex2f(-0.8f,0.0f);
				glVertex2f(-0.0f,0.0f);
				glVertex2f(-0.0f,0.8f);
			glEnd();

			glColor4f(1.0f,1.0f,1.0f,0.75f);

			Text_Printf(0,-0.7f,0.73f,"Director:");
			Text_Printf(0,-0.75f,0.66f,"faceH0r   www.faceH0r.narod.ru");
			Text_Printf(0,-0.7f,0.59f,"Special thanks to:");
			Text_Printf(0,-0.75f,0.52f,"jnz       www.Calypso3.narod.ru");
			Text_Printf(0,-0.75f,0.45f,"Tiangond  www.Tiandong.narod.ru");
			Text_Printf(0,-0.7f,0.38f,"Sound from games:");
			Text_Printf(0,-0.75f,0.31f,"Quake 3");
			Text_Printf(0,-0.75f,0.24f,"Counter Strike");
			Text_Printf(0,-0.75f,0.17f,"Serious Sam");
		}

		glColor4f(1.0f,1.0f,1.0f,0.75f);
		Text_Printf(0,-0.3f,-0.95f,"Created by faceH0r 12.08.2005");
	}
}

// ===============================================================================================

void FPS_Render(){
	glColor4f(1.0f,1.0f,1.0f,1.0f);

	Text_Printf(0,0.75f,0.95f,"FPS:%3.2f",1000.0f/mm.time_Delta);
}

// ===============================================================================================

void Render_GetBonus(){
	glColor4f(1.0f,1.0f,1.0f,rbonus.f_Blend);

	rbonus.f_Blend-=mm.time_Delta/2500.0f;

	Text_Printf(0,0.0f,0.9f,rbonus.name);

	glColor4f(1.0f,1.0f,1.0f,1.0f);
}

// ===============================================================================================

void Player_TestDead(){
	if(plr.p_Health<=0.0f){
		if(!plr.b_Dead){
			OAL_Play(8);

			s_static_sprite sspr;

			sspr.f_Blend=1.0f;
			sspr.f_Size=0.05f;
			sspr.f_SpeedDestroy=0.0f;
			sspr.ui_TextureNumber=t_FF[GetTextureByName("Textures/MarineDead.bmp")].i_Number;
			sspr.v_Dir=plr.v_Dir;
			sspr.v_Pos=plr.v_Pos;

			Sprite_Add(sspr);

			Animation_Del(0);

			for(int i=0;i<c_Monsters;i++)
				mst[i].nmb_Anim--;
		}

		plr.b_Dead=true;

		mm.f_PressAnyKey+=mm.time_Delta;
	}
}

// ===============================================================================================

void New_Game(){
	int i;

	mm.game_BuyMenu=false;

	memset(&plr,0,sizeof(plr));

	for(i=0;i<c_Animation;i++)
		memset(&ani[i],0,sizeof(ani[i]));

	for(i=0;i<c_Monsters;i++)
		memset(&mst[i],0,sizeof(mst[i]));

	for(i=0;i<c_Bonus;i++)
		memset(&bns[i],0,sizeof(bns[i]));

	for(i=0;i<c_Bullets;i++)
		memset(&blt[i],0,sizeof(blt[i]));

	for(i=0;i<c_Particles;i++)
		memset(&par[i],0,sizeof(par[i]));

	for(i=0;i<c_SoundBuffers;i++)
		memset(&sndb[i],0,sizeof(sndb[i]));

	for(i=0;i<c_Sprites;i++)
		memset(&spr[i],0,sizeof(spr[i]));

	c_Animation=0;
	c_Monsters=0;
	c_Bonus=0;
	c_Bullets=0;
	c_Particles=0;
	c_SoundBuffers=0;
	c_Sprites=0;

	fTimer = 0.0f;

	mm.player_Score=0;
	mm.f_PressAnyKey=0.0f;

	mm.f_StartSpeedRespawn=1000.0f;

	Setting_Weapon(RGS_IDENT_PISTOL, "Pistol",    7, 500, 1000);
	Setting_Weapon(RGS_IDENT_AK,     "AK",        30,100, 2000);
	Setting_Weapon(RGS_IDENT_SHOTGUN,"ShotGun",   7, 1000,2500);
	Setting_Weapon(RGS_IDENT_GRENADE,"GrenadeGun",1, 0,   2000);

	bool		b_Get = false;

	for(i = 0; i < plr.count_Weapons; i ++)
		if(plr.w_Id[i] == RGS_IDENT_PISTOL)
			b_Get = true;

	if(!b_Get)
		Player_AddWeapon(RGS_IDENT_PISTOL);

	plr.p_Health=100.0f;
	plr.p_RunPower=100.0;
	plr.i_CountSpecial=8;
	plr.f_SpeedDestroyTrace=0.001f;
	plr.f_TimeBetweenTrace=50.0f;
	plr.f_RecoverPowerRunSpeed=0.005f;
	plr.v_Vel.vecSet(0.0f,1.0f);
	plr.v_Dir.vecSet(0.0f,1.0f);
	plr.i_NumberAnimation=0;

	mm.f_SoundDamage=1000.0f;

	// Test add animation player
	s_animation_sprite anis;

	anis.b_Play=true;
	anis.f_Blend=1.0f;
	anis.f_CurrentTime=0.0f;
	anis.f_Size=0.05f;
	anis.f_SpeedAnimation=20.0f;
	anis.f_SpeedDestroy=0.0f;
	anis.i_CountFrames=16;
	anis.i_CurrentFrame=0;
	anis.ui_TextureNumber=t_FF[GetTextureByName("Textures/Marine.bmp")].i_Number;
	anis.v_Dir.vecSet(1.0f,0.0f);
	anis.v_Pos.vecSet(0.0f,0.0f);

	Animation_Add(anis);
}

// ===============================================================================================

void RedGutS_LoadSettings(const char *name)
{
	FILE *infile;

	int ii[5];
	float ff;

	infile=fopen(name,"r");

	if(infile)
	{
		fscanf(infile,"%i %i %i %i %f %i",&ii[0],&ii[1],&ii[2],&ii[3],&ff,&ii[4]);

		memset(&mm.dm,0,sizeof(mm.dm));

		mm.dm.dmSize=sizeof(mm.dm);

		mm.dm.dmPelsWidth=ii[1];
		mm.dm.dmPelsHeight=ii[2];
		mm.dm.dmBitsPerPel=ii[3];

		mm.f_SpeedRespawn=ff;

		mm.i_ShowFPS=ii[4];

		if(mm.dm.dmPelsWidth!=800&&mm.dm.dmPelsWidth!=640&&mm.dm.dmPelsWidth!=1024)	// If screen mode error
		{
			mm.dm.dmPelsWidth=1024;
			mm.dm.dmPelsHeight=768;

			MessageBox(mm.hWnd,"Error screen mode","Settings.ini",MB_OK);
		}

		mm.sc_Width=mm.dm.dmPelsWidth;
		mm.sc_Height=mm.dm.dmPelsHeight;

		if(ii[0]!=0)
		{
			mm.dm.dmFields=DM_PELSWIDTH|DM_PELSHEIGHT|DM_BITSPERPEL;

			ChangeDisplaySettings(&mm.dm,CDS_FULLSCREEN);
		}

		fclose(infile);
	}
	else
		MessageBox(mm.hWnd,name,"File not found!",MB_OK);
}

// ===============================================================================================

void RedGutS_Render(){
//	glClear(GL_COLOR_BUFFER_BIT);

	if(mm.game_BuyMenu||mm.game_Menu||mm.game_Pause)
		mm.speed_Game=0.0f;
	else
		mm.speed_Game=1.0f;

	if(mm.game_BuyMenu)
		Mouse_Test();

	if(!plr.b_Dead)
		RedGutS_ProcessKeys();

	if(!plr.b_Dead)
		Monster_Random(1.0f,500.0f);

	Background_Render();
	Sprite_Render();
	Particle_Render();
	Bonus_Render();
	Bullet_Render();
	Monster_Render();
	
	Player_TestDead();
	
	Animation_Render();

	if(!plr.b_Dead)
		Player_Render();

	Render_GetBonus();

	if(mm.i_ShowFPS)
		FPS_Render();

	if(!plr.b_Dead)
		fTimer += mm.time_Delta / 1000.0f;
	Text_Printf(0,0.55f,0.90f,"Game time:%5.2f",fTimer);

	glColor4f(1.0f,1.0f,1.0f,0.75f);

	if(plr.b_Dead){
		Text_Printf(1,-0.25f,0.0f,"Game Over");
		Text_Printf(0,-0.165f,-0.05f,"Press any key...");
	}

	glColor4f(1.0f,1.0f,1.0f,1.0f);

	GameMenu_Render();

	glDisable(GL_TEXTURE_2D);
	
//	glBegin(GL_POINTS);	
//		glColor3f(1,1,1);
//
//		glVertex2f(plr.v_Pos.x+plr.v_DirMove.x/5,plr.v_Pos.y+plr.v_DirMove.y/5);
//
//		glColor3f(1,0,0);
//		glVertex2f(plr.v_Pos.x+plr.v_Vel.x/5,plr.v_Pos.y+plr.v_Vel.y/5);
//	glEnd();

//	glColor4f(1,1,1,1);
//	Text_Printf(0,0,0,"%i",::c_Bullets);

	glEnable(GL_TEXTURE_2D);

	SwapBuffers(mm.hDc);
}

// ===============================================================================================

void RedGutS_Exit(){
	wglDeleteContext(mm.hRc);
	ReleaseDC(mm.hWnd,mm.hDc);

	PostQuitMessage(0);
}

// ===============================================================================================

void Weapon_TestGet(const int &w_id){
	for(int i=0;i<plr.count_Weapons;i++)
		if(plr.w_Id[i]==w_id){
			plr.current_Weapon=w_id-100;	// If you don't understand see function Setting_Weapon

			plr.f_CurrentReloadWeaponTime=0.0f;
		}
}

// ===============================================================================================

LRESULT CALLBACK WndProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam){
	switch(uMsg){
	case WM_LBUTTONDOWN:
		mm.lbtn=true;

		break;
	case WM_LBUTTONUP:
		mm.lbtn=false;

		if(mm.select_nmb==1)
			New_Game();

		if(mm.select_nmb==2)
			if(!mm.b_score)
				mm.b_score=true;
			else
				mm.b_score=false;

		if(mm.select_nmb==3)
			PostQuitMessage(0);

		break;
	case WM_RBUTTONDOWN:
		mm.rbtn=true;

		break;
	case WM_RBUTTONUP:
		mm.rbtn=false;

		break;
	case WM_CREATE:
		mm.hWnd=hWnd;

		RedGutS_Init();
		break;
	case WM_KEYDOWN:
		if(plr.b_Dead&&mm.f_PressAnyKey>=2000.0f)
			mm.game_BuyMenu=true;

		switch(wParam){
		case '1':
			if(!mm.game_BuyMenu&&!plr.b_Dead)
				Weapon_TestGet(RGS_IDENT_PISTOL);

			break;
		case '2':
			if(!mm.game_BuyMenu&&!plr.b_Dead)
				Weapon_TestGet(RGS_IDENT_AK);

			break;
		case '3':
			if(!mm.game_BuyMenu&&!plr.b_Dead)
				Weapon_TestGet(RGS_IDENT_SHOTGUN);

			break;
		case '4':
			if(!mm.game_BuyMenu&&!plr.b_Dead)
				Weapon_TestGet(RGS_IDENT_GRENADE);

			break;
		case VK_ESCAPE:
			if(!plr.b_Dead)
				if(mm.game_BuyMenu){
					SetCursorPos(mm.m_PosPause.x,mm.m_PosPause.y);
					mm.game_BuyMenu=false;
				}else{
					GetCursorPos(&mm.m_PosPause);
					mm.game_BuyMenu=true;
				}

			break;
		}

		mm.keys[wParam]=true;

		break;
	case WM_KEYUP:
		mm.keys[wParam]=false;

		break;
	case WM_DESTROY:
		RedGutS_Exit();
		break;
	default:
		return DefWindowProc(hWnd,uMsg,wParam,lParam);
		break;
	}
}

// ===============================================================================================

WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nShowCmd){
	memset(&mm.m_Wc,0,sizeof(WNDCLASSEX));

	mm.m_Wc.cbSize=sizeof(WNDCLASSEX);
	mm.m_Wc.lpszClassName="ClassRedGutS";
	mm.m_Wc.lpfnWndProc=WndProc;

	RegisterClassEx(&mm.m_Wc);

	RedGutS_LoadSettings("Settings.ini");

	mm.hWnd=CreateWindowEx(0,"ClassRedGutS","Red GutS Game",WS_POPUP,0,0,mm.dm.dmPelsWidth,mm.dm.dmPelsHeight,0,0,0,0);

	ShowWindow(mm.hWnd,SW_SHOW);

	mm.time_Old=GetTickCount();

	mm.speed_Game=1.0f;

	while(mm.uMsg.message!=WM_QUIT){
		if(PeekMessage(&mm.uMsg,0,0,0,PM_REMOVE)){
			TranslateMessage(&mm.uMsg);
			DispatchMessage(&mm.uMsg);
		}else{
			mm.time_Current=GetTickCount();
			mm.time_Delta=(mm.time_Current-mm.time_Old)*mm.speed_Game;
			mm.time_Old=mm.time_Current;

			RedGutS_Render();
		}
	}

	return 0;
}

// ===============================================================================================
//  End
// ===============================================================================================
